# coding: utf-8

"""
    Grounding Hub REST API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.0.3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from groundinghub.models.author import Author
from groundinghub.models.position import Position
from typing import Optional, Set
from typing_extensions import Self

class DocumentMetadata(BaseModel):
    """
    Information about the source document and the current data
    """ # noqa: E501
    source_mime_type: Optional[StrictStr] = Field(default=None, description="Type of the source document, e.g., application/pdf, text/csv, application/vnd.youtube.yt (see https://www.iana.org/assignments/media-types/media-types.xhtml)")
    title: Optional[StrictStr] = Field(default=None, description="Title of the document, if available")
    authors: Optional[List[Author]] = Field(default=None, description="List of authors of the document")
    mime_type: Optional[StrictStr] = Field(default=None, description="Type of the data, e.g., text/plain, video/3gpp, image/png (see https://www.iana.org/assignments/media-types/media-types.xhtml)")
    url: Optional[StrictStr] = Field(default=None, description="URL to the original document")
    created: Optional[datetime] = Field(default=None, description="Source document creation date-time. the date-time notation as defined by RFC 3339, section 5.6, for example, 2023-07-21T17:32:28Z")
    tags: Optional[List[StrictStr]] = Field(default=None, description="List of tags assigned to the source document (see ```RAGConfig.document_tags```).")
    position: Optional[Position] = None
    __properties: ClassVar[List[str]] = []

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DocumentMetadata from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DocumentMetadata from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
        })
        return _obj


